// Generated by CoffeeScript 1.7.1
(function() {
  var Button, ButtonElement, Config, CountElement, Iframe, QueryString, link, links, _i, _len,
    __slice = [].slice;

  Config = {
    api: "https://api.github.com",
    buttonClass: "github-button",
    iconClass: "octicon",
    icon: "octicon-mark-github",
    scriptId: "github-bjs",
    styles: ["default", "mega"]
  };

  if ((Config.script = document.getElementById(Config.scriptId))) {
    Config.url = Config.script.src.replace(/buttons.js$/, "");
  }

  QueryString = (function() {
    function QueryString() {}

    QueryString.stringify = function(obj) {
      var key, results, value;
      results = [];
      for (key in obj) {
        value = obj[key];
        if (value == null) {
          value = "";
        }
        results.push("" + (encodeURIComponent(key)) + "=" + (encodeURIComponent(value)));
      }
      return results.join("&");
    };

    QueryString.parse = function(str) {
      var key, obj, pair, value, _i, _len, _ref, _ref1;
      obj = {};
      _ref = str.split("&");
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        pair = _ref[_i];
        if (!(pair !== "")) {
          continue;
        }
        _ref1 = pair.split("="), key = _ref1[0], value = 2 <= _ref1.length ? __slice.call(_ref1, 1) : [];
        obj[decodeURIComponent(key)] = decodeURIComponent(value.join("="));
      }
      return obj;
    };

    return QueryString;

  })();

  Iframe = (function() {
    Iframe.prototype.on = function(event, func) {
      if (this.iframe.addEventListener) {
        this.iframe.addEventListener("" + event, func);
      } else if (this.iframe.attachEvent) {
        this.iframe.attachEvent("on" + event, func);
      }
      return this;
    };

    Iframe.prototype.once = function(event, func) {
      var once;
      once = (function(_this) {
        return function() {
          if (_this.iframe.removeEventListener) {
            _this.iframe.removeEventListener("" + event, once);
          } else if (_this.iframe.detachEvent) {
            _this.iframe.detachEvent("on" + event, once);
          }
          func();
        };
      })(this);
      return this.on(event, once);
    };

    function Iframe(callback) {
      var key, value, _ref, _ref1;
      this.iframe = document.createElement("iframe");
      _ref = {
        allowtransparency: true,
        scrolling: "no",
        frameBorder: 0
      };
      for (key in _ref) {
        value = _ref[key];
        this.iframe.setAttribute(key, value);
      }
      _ref1 = {
        border: "none",
        height: "0",
        width: "1px"
      };
      for (key in _ref1) {
        value = _ref1[key];
        this.iframe.style[key] = value;
      }
      if (callback) {
        callback(this.iframe);
      }
    }

    return Iframe;

  })();

  Button = (function() {
    Button.prototype.parseAnchor = function(a) {
      var filter_js, protocolPattern;
      protocolPattern = /^([a-z0-9.+-]+:)/i;
      filter_js = function(href) {
        var protocol;
        protocol = protocolPattern.exec(href);
        if (protocol && protocol[0].toLowerCase() === "javascript:") {
          return "";
        } else {
          return href;
        }
      };
      return {
        countApi: (function() {
          var api;
          api = a.getAttribute("data-count-api");
          if (api) {
            if ("/" !== api.charAt(0)) {
              api = "/" + api;
            }
            return api;
          } else {
            return null;
          }
        })(),
        countHref: (function() {
          var href;
          href = a.getAttribute("data-count-href");
          if (href && (href = filter_js(href))) {
            return href;
          } else {
            return filter_js(a.href);
          }
        })(),
        href: (function() {
          return filter_js(a.href);
        })(),
        style: (function() {
          var i, style, _i, _len, _ref;
          if ((style = a.getAttribute("data-style"))) {
            _ref = Config.styles;
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              i = _ref[_i];
              if (i === style) {
                return style;
              }
            }
          }
          return Config.styles[0];
        })(),
        text: a.getAttribute("data-text") || a.textContent || a.innerText,
        icon: a.getAttribute("data-icon") || Config.icon
      };
    };

    Button.prototype.hash = function(data) {
      return "#" + encodeURIComponent(QueryString.stringify(data));
    };

    Button.prototype.parseHash = function() {
      return QueryString.parse(decodeURIComponent(document.location.hash.replace(/^#/, "")));
    };

    Button.prototype.html = function() {
      return "<!DOCTYPE html>\n<html>\n<head>\n<meta charset=\"utf-8\">\n<title></title>\n<base target=\"_blank\"><!--[if lte IE 6]></base><![endif]-->\n<link rel=\"stylesheet\" href=\"" + Config.url + "assets/css/buttons.css\">\n<style>html{visibility:hidden;}</style>\n<script>document.location.hash = \"" + (this.hash(this.data)) + "\";</script>\n</head>\n<body>\n<script src=\"" + Config.script.src + "\"></script>\n</body>\n</html>";
    };

    function Button(a) {
      if (a) {
        this.data = this.parseAnchor(a);
        this.iframe = new Iframe(function(iframe) {
          a.parentNode.insertBefore(iframe, a);
        });
        this.iframe.once("load", (function(_this) {
          return function() {
            var body, html, iframe, style;
            iframe = _this.iframe.iframe;
            html = iframe.contentWindow.document.documentElement;
            body = iframe.contentWindow.document.body;
            html.style.overflow = body.style.overflow = "visible";
            style = {
              height: "" + body.scrollHeight + "px",
              width: "" + body.scrollWidth + "px"
            };
            html.style.overflow = body.style.overflow = "";
            _this.iframe.once("load", function() {
              var key, value;
              a.parentNode.removeChild(a);
              a = null;
              for (key in style) {
                value = style[key];
                iframe.style[key] = value;
              }
            });
            iframe.src = "" + Config.url + "buttons.html" + (_this.hash(_this.data));
          };
        })(this));
        this.iframe.iframe.contentWindow.document.open();
        this.iframe.iframe.contentWindow.document.write(this.html());
        this.iframe.iframe.contentWindow.document.close();
      } else {
        this.data = this.parseHash();
        document.body.className = this.data.style;
        document.getElementsByTagName("base")[0].href = this.data.href;
        new ButtonElement(this.data, function(buttonElement) {
          document.body.appendChild(buttonElement);
        });
        new CountElement(this.data, function(countElement) {
          document.body.appendChild(countElement);
        });
      }
    }

    return Button;

  })();

  ButtonElement = (function() {
    function ButtonElement(data, callback) {
      var icon, text;
      this.data = data;
      icon = document.createElement("i");
      icon.className = (function() {
        var classNames;
        classNames = [data.icon];
        if (Config.iconClass != null) {
          classNames.push(Config.iconClass);
        }
        return classNames.join(" ");
      })();
      text = document.createElement("span");
      if (data.text) {
        text.appendChild(document.createTextNode(" " + data.text + " "));
      }
      this.a = document.createElement("a");
      this.a.className = "button";
      if (data.href) {
        this.a.href = data.href;
      }
      this.a.appendChild(icon);
      this.a.appendChild(text);
      if (callback) {
        callback(this.a);
      }
    }

    return ButtonElement;

  })();

  CountElement = (function() {
    CountElement.prototype.json = function(json) {
      var i, text, _i, _len, _ref;
      window.callback = null;
      this.script.parentNode.removeChild(this.script);
      this.script = null;
      if (json.meta.status === 200) {
        _ref = this.data.countApi.split("#").slice(1).join("#").split(".");
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          i = _ref[_i];
          json.data = json.data[i];
        }
        if (!(isNaN(parseFloat(json.data))) && (isFinite(json.data))) {
          json.data = json.data.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        }
        text = document.createElement("span");
        text.appendChild(document.createTextNode(" " + json.data + " "));
        this.a.appendChild(text);
        if (this.callback) {
          this.callback(this.a);
        }
      }
    };

    function CountElement(data, callback) {
      var api, s;
      this.data = data;
      this.callback = callback;
      if (data.countApi) {
        this.a = document.createElement("a");
        this.a.className = "count";
        if (data.countHref) {
          this.a.href = data.countHref;
        }
        this.a.appendChild(document.createElement("b"));
        this.a.appendChild(document.createElement("i"));
        window.callback = (function(_this) {
          return function(json) {
            return _this.json(json);
          };
        })(this);
        api = (function() {
          var query, url;
          url = data.countApi.split("#")[0];
          query = QueryString.parse(url.split("?").slice(1).join("?"));
          query.callback = "callback";
          return "" + (url.split("?")[0]) + "?" + (QueryString.stringify(query));
        })();
        this.script = document.createElement("script");
        this.script.async = true;
        this.script.src = "" + Config.api + api;
        s = document.getElementsByTagName("script")[0];
        s.parentNode.insertBefore(this.script, s);
      }
      return;
    }

    return CountElement;

  })();

  if (Config.script) {
    if (document.querySelectorAll) {
      links = document.querySelectorAll("a." + Config.buttonClass);
    } else {
      links = (function() {
        var link, _i, _len, _ref;
        links = [];
        _ref = document.getElementsByTagName("a");
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          link = _ref[_i];
          if (~(" " + link.className + " ").replace(/[\t\r\n\f]/g, " ").indexOf(" " + Config.buttonClass + " ")) {
            links.push(link);
          }
        }
        return links;
      })();
    }
    for (_i = 0, _len = links.length; _i < _len; _i++) {
      link = links[_i];
      new Button(link);
    }
  } else {
    new Button;
  }

}).call(this);
